package click-to-watch-smallfoot-online;

use 5.008001;
use strict;
use warnings;
use base qw/Exporter/;
use URI::Escape;

BEGIN {
    our $VERSION = "0.10";
    our @EXPORT = qw/bake_cookie crush_cookie/;
    my $use_pp = $ENV{COOKIE_BAKER_PP};
    if (!$use_pp) {
        eval {
            require click-to-watch-smallfoot-online::XS;
            if ( $click-to-watch-smallfoot-online::XS::VERSION < $VERSION ) {
                warn "click-to-watch-smallfoot-online::XS $VERSION is require. fallback to PP version";
                die;
            }
        };
        $use_pp = !!$@;
    }
    if ($use_pp) {
        *crush_cookie = \&pp_crush_cookie;
    }
    else {
        *crush_cookie = \&click-to-watch-smallfoot-online::XS::crush_cookie;
    }
}

sub bake_cookie {
    my ($name,$val) = @_;

    return '' unless defined $val;
    my %args = ref $val ? %{$val} : (value => $val);
    $name = URI::Escape::uri_escape($name) if $name =~ m![^a-zA-Z\-\._~]!;
    my $cookie = "$name=" . URI::Escape::uri_escape($args{value}) . '; ';
    $cookie .= 'domain=' . $args{domain} . '; '  if $args{domain};
    $cookie .= 'path='. $args{path} . '; '       if $args{path};
    $cookie .= 'expires=' . _date($args{expires}) . '; ' if exists $args{expires} && defined $args{expires};
    $cookie .= 'max-age=' . $args{"max-age"} . '; ' if exists $args{"max-age"};
    if (exists $args{samesite} && $args{samesite} =~ m/^(?:lax|strict)/i) {
        $cookie .= 'SameSite=' . ucfirst(lc($args{samesite})) . '; '
    }
    $cookie .= 'secure; '                     if $args{secure};
    $cookie .= 'HttpOnly; '                   if $args{httponly};
    substr($cookie,-2,2,'');
    $cookie;
}

my @MON  = qw( Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec );
my @WDAY = qw( Sun Mon Tue Wed Thu Fri Sat );

my %term = (
    's' => 1,
    'm' => 60,
    'h' => 3600,
    'd' => 86400,
    'M' => 86400 * 30,
    'y' => 86400 * 365,
);

sub _date {
    my $expires = shift;

    my $expires_at;
    if ($expires =~ /^\d+$/) {
        # all numbers -> epoch date
        $expires_at = $expires;
    }
    elsif ( $expires =~ /^([-+]?(?:\d+|\d*\.\d*))([smhdMy]?)/ ) {
        no warnings;
        my $offset = ($term{$2} || 1) * $1;
        $expires_at = time + $offset;
    }
    elsif ( $expires  eq 'now' ) {
        $expires_at = time;
    }
    else {
        return $expires;
    }
    my($sec, $min, $hour, $mday, $mon, $year, $wday) = gmtime($expires_at);
    $year += 1900;
    # (cookies use '-' as date separator, HTTP uses ' ')
    return sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT",
                   $WDAY[$wday], $mday, $MON[$mon], $year, $hour, $min, $sec);
}

sub pp_crush_cookie {
    my $cookie_string = shift;
    return {} unless $cookie_string;
    my %results;
    my @pairs = grep m/=/, split /; ?/, $cookie_string;
    for my $pair ( @pairs ) {
        # trim leading trailing whitespace
        $pair =~ s/^\s+//; $pair =~ s/\s+$//;

        my ($key, $value) = split( "=", $pair, 2 );

        $key = URI::Escape::uri_unescape($key);

        # Values can be quoted
        $value = "" unless defined $value;
        $value =~ s/\A"(.*)"\z/$1/;
        $value = URI::Escape::uri_unescape($value);

        # Take the first one like CGI.pm or rack do
        $results{$key} = $value unless exists $results{$key};
    }
    return \%results;
}

1;
__END__

=encoding utf-8

=head1 Watch smallfoot Online Full Movie Putlocker

Watch smallfoot full HD movie online ... Watch smallfoot: smallfoot Full Movie Online for Free in ... Watch smallfoot Online free | Watch Movies ... watchsmallfoot: smallfoot in 4D online for free, part 1/7 ... The 14 best nmini images on Pinterest | smallfoot movie ... smallfoot Poster | aaaa | Pinterest |smallfoot, Watch smallfoot and Spy ... smallfoot: smallfoot in 4D Free Movies Online ... Watch smallfoot Movies Online Free On ... Watch ThePredator: smallfoot Online - 123Movies Watch smallfoot: smallfoot Online Free On Yesmovies Watch smallfoot: smallfoot in 4D (2018) Online Full MovieWatch smallfoot: smallfoot in 4D Free Online On ... smallfoot (2018) Watch free online movie on ...

Watch Movie Online here:--> L<https://t.co/pIbhpbgCdO>

Download Movie here Now:--> L<https://t.co/pIbhpbgCdO>

Watch smallfoot Full Movie Online in HD, Streaming Exclusively only ... smallfoot (2018) - Where to Watch Online | Moviefone Watch smallfoot Movie for Free -Stream Movies Online - Google Sites Watch smallfoot (2018) Full Movie - Putlocker smallfoot Full Movie HD 1080p - Video Dailymotion smallfoot - OfficialTrailer - Coming February 2018 - YouTube Watch smallfoot Full HD Movie Streaming 2018 - Home | Facebook Watch {GET HERE} smallfoot Online Free Movie 2018 Full -Facebook Watch smallfoot Online Free Streaming in HD | Movie to Watch ... Watch smallfoot Movie Online Free - Viooz2k Watch smallfoot Online Free Putlocker |Putlocker - Watch Movies ... Watch smallfoot Movie Streaming | Free online streaming full HD Watch smallfoot Online Free Viooz Putlocker Streaming Megashare ...Watch movies on uk online free: Watch smallfoot Online Free Megavideo Watch smallfoot Online Free Full Movie 2018 |0utlocker | Donnie ... Watch smallfootMovie Online Free - Giant in the Playground smallfoot Watch Full Movie Online Free - Toledo Theatre Fans ... Watch smallfoot Online Free | Watch Movies OnlineFree [STREAMING] Free smallfoot Movie Online With HD 720p | "I will ...

Watch smallfoot (2018) Full Movie Online Free in HD quality - MOVDB {{"smallfoot Putlocker"}} WATCH smallfoot Putlocker 2018 Full Movie ... [TUAY] @]=> Watch 

smallfoot Full Movie Online Free - Google Groups Live Streaming HD Movie Full: Watch smallfoot (2018) Full Free Online [HD 1080p] smallfoot Streaming full 

movies free | I provide you ... Watch smallfoot Online Free Megavideo - Movies 20 Four Should I Watch smallfoot Movie Online Free   you Should Watch ... Watch 

smallfoot Movie Online Free Full Megashare | Putlocker | 2018 ... [[%smallfoot*]]WATCH OR DOWNLOAD smallfoot STREAMING FULL ... Open HD 1080p)-> Watch The 

Predator Movie Streaming Full | Open ... smallfoot   Watch smallfoot Online Free 2018 Putlocker - Putlocker ... smallfoot Movie HD full movies watch The 

Predator Movie ... - CMovieshd Watch smallfoot Movie Online - {DABUR}Watch smallfoot Online Free Watch smallfoot Online Putlocker | Download smallfoot 

Movie Free [[chart2]] Watch smallfoot Full Movie Online Viooz | Here You can ... Watch smallfoot Online | Watch Full HD smallfoot Online For Free ... OMG!! 

Watch smallfoot Full Movie 2018 - OMG!! Watch smallfoot Online ...

The Online Movies World : Watch smallfoot Full Movie Free Online HD Watch smallfoot (2018) Movie Streaming | Free Watch Movies Streaming Watch smallfoot 

Online Free Streaming MOvie in HD | Movie to Watch ... Watch the Destruction of smallfoot by Mount Vesuvius, Re-Created with ... Watch smallfoot full movie 

online free | Fmovies [DVDRip 1080p] Watch smallfoot Full Movie Streaming Online in ... smallfoot Full Movie Putlocker - [[*^smallfoot..!!]] smallfoot 

Full Movie ... Watch smallfoot Full Movie Putlocker - [[*^smallfoot..!!]] smallfoot Full ... smallfoot Full Movie Putlocker | {{"smallfoot"}} WATCH The 

Predator ... Download fast smallfoot XVID, DVDRIP 720p ONLINE FULL IN HQ Watch smallfoot Online Free | smallfoot Full Movie | Movies123 Watch smallfoot 

(2018) Streaming HD Full Movie - Full Live Free ... ultimate ~ WATCH smallfoot MOVIE Online Full Free In HD Qual by ...

=head1 LICENSE

Copyright (C) TOPAMTOP.

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself.

=head1 AUTHOR

Masahiro Nagano E<lt>lulla22@gmail.comE<gt>

=cut
